// #autoload
// #name = string matching
// #version = 1.00
// #author = Barbarian
// #warrior = Barb4rian
// #email = conanford@hotmail.com
// #web = http://barb4rian.tripod.com/
// #description = wildcard string matching
// #credit = Julian Robichaux (author of Java version)
// #status = done
// #category = barbarian
//
// basic string character matching for Tribes 2
// based on PatternMatch.java ( http://www.nsftools.com/tips/PatternMatch.java) by Julian Robichaux
// modified for Tribes 2 .cs scripting by Conan Ford, conanford@hotmail.com
//
// supports ? and *.  Does NOT support [] since writing this part into Tribes 2 is no fun at all
// Due to Tribes 2 constraints, is NOT case sensitive, unlike the original
//
// This code is distributed according to the following license:
// Quote from PatternMatch.java
//  * You may use this code as you wish, just don't pretend 
//  * that you wrote it yourself, and don't hold me liable for 
//  * anything that it does or doesn't do. If you're feeling 
//  * especially honest, please include a link to nsftools.com
//  * along with the code.
//
// Modified for server-side by Lexor for RevMod2 
// RevMod2 Lexor 12-14-2003
//
// recursion limit.  keeps from accidental infinite loop
// RevMod2 Lexor 12-14-2003
// turn this into a global setting
$RevStringMatch::maxrecursion=10;

// this one will need to be per-client
//$isMatch::posrecursion=0;

function RevStringMatch(%checkString,%pattern,%client,%admin)
{

// RevMod2 Lexor 12-14-2003
// instead of isMatch::posrecursion
// we have to use a per-client variable
// otherwise this won't work if more than 1 client uses it at once

// ok this is how we'll do it...
// isMatch::posrecursion will change to
// %client.posrecursion
// AND
// if you want to call this function,
// YOU HAVE TO SET IT TO =0 BEFORE CALLING STRING MATCH !!
// cheap hack, but hey why not
// hmm, wonder how this ever worked before

	%client.posrecursion++;
	if(%client.posrecursion > $RevStringMatch::maxrecursion)
	{
		error("isMatch exceeded recursion limit");
		%client.posrecursion--;
		return false;
	}
	%checkStringlength=strlen(%checkString);
	%patternlength=strlen(%pattern);

	for (%i = 0; %i < %checkStringlength; %i++)
	{
		// if we're at the end of the pattern but not the end
		// of the string, return false
		if (%patternPos >= %patternlength)
		{
			%client.posrecursion--;
			return false;
		}
		
		// grab the characters we'll be looking at
		%patternChar = getsubstr(%pattern,%patternPos,1);
		%thisChar = getsubstr(%checkString,%i,1);
		
		
		switch$ (%patternChar)
		{
			// check for '*', which is zero or more characters
			case "*":
				// if this is the last thing we're matching,
				// we have a match
				if (%patternPos >= (%patternlength - 1))
				{
					%client.posrecursion--;
					return true;
				}
				
				// otherwise, do a recursive search
				for (%j = %i; %j < %checkStringlength; %j++)
				{
//					if (isMatch(getsubstr(%checkString,%j,%checkStringlength), getsubstr(%pattern,%patternPos + 1,%patternlength)))
					if (RevStringMatch(getsubstr(%checkString,%j,%checkStringlength), getsubstr(%pattern,%patternPos + 1,%patternlength)))
					{
						%client.posrecursion--;
						return true;			
					}
				}
				
				// if we never returned from that, there is no match
				%client.posrecursion--;
				return false;
				
				
			// check for '?', which is a single character
			case "?":
				// do nothing, just advance the patternPos at the end	

			default :
				// the default condition is to do an exact character match
				if (%thisChar !$= %patternChar)
				{
					%client.posrecursion--;
					return false;
				}
				
		}
		
		// advance the patternPos before we loop again
		%patternPos++;
		
	}
	
	// if there's still something in the pattern string, check to
	// see if it's one or more '*' characters. If that's all it is,
	// just advance to the end
	for (%j = %patternPos; %j < %patternlength; %j++)
	{
		if (getsubstr(%pattern,%j,1) !$= "*")
			break;
	}
	%patternPos = %j;
	
	// at the end of all this, if we're at the end of the pattern
	// then we have a good match

	%client.posrecursion--;
	if (%patternPos == %patternlength)
		return true;
	else
		return false;
	
}

