//-----------------------------------------------------------------------------
// "PilotBot" - Piloting AI v2.0
// (c) 2001 Josef "Werewolf" Jahn
// http://www.playspoon.com
//-----------------------------------------------------------------------------
//
// based on code in "AiDebug.cs" by Dynamix
// This code is free for everyone to use but if you do, please write a short email 
// to werewolf359@playspoon.com so I can check out your cool mod too.
//
//-----------------------------------------------------------------------------
// Dedicated to everyone with a slow or no internet connection. Botfighting rules.
// It's not about how "l33t" some folks are - it's just a game, hence it's about having fun.
// Don't let slobs and morons ruin your day. They don't count. Maybe some of them can disc you
// in mid-air and rub the fact under your nose everytime, but therefore they don't have a life.
// - Sorry, I just had to let this out :)
//-----------------------------------------------------------------------------

$PilotDebug = 0;
$PilotVersion = "v2.1";
$BotPilotWaitTime = 3000; // BotPilot will wait 30 seconds for passengers if the vehicle is not yet full --Cessen
//ShoulderMissile.lifeTimeMs = 10000;
$MissileLauncherAimTime = 600;

// ZOD 2-3-03: Added isObject console spam fixes
function MissileDudeAimAtTarget(%client, %percent)
{
   if(isObject(%client.pilotTask.target))
      %endPos = %client.pilotTask.target.getWorldBoxCenter();

   if(isObject(%client.player))
   {
      //calculate the start position
      %startTransform = %client.player.getTransform();
      %startDirection = MatrixMulVector("0 0 0 " @ getWords(%startTransform, 3, 6), "0 1 0");
      %startDirection = VectorNormalize(%startDirection);
      %startPos = VectorAdd(getWords(%startTransform, 0, 2), VectorScale(%startDirection, 100));

      //now calculate the aim position
      %vec = VectorSub(%endPos, %startPos);
      %length = VectorDist(%endPos, %startPos);
      %vec = VectorNormalize(%vec);
      %aimPos = VectorAdd(%startPos, VectorScale(%vec, %percent * %length));

      //now aim the client there
      %client.aimAt(%aimPos, 2000);

      //schedule the next aim
      if ((%client.pilotTask.target != -1) && (%client.pilotTask.target != -1) && (%client.pilotTask.target !$= ""))
      {
	   if (%percent <= 0.9)
		schedule($MissileLauncherAimTime / 10, 0, MissileDudeAimAtTarget, %client, %percent + 0.1);
	   else
		MissileDudeFireMissile(%client);
      }
   }
}

function MissileDudeFireMissile(%Client)
{
   %client.stop();
   %client.clearStep();
   %client.setEngageTarget(-1);
   %client.setTargetObject(%Client.pilotTask.target, 300, "Missile");
   %client.pilotTask.target = -1;
      
//   %wav = "voice/derm2/gbl.woohoo.WAV";
//   %audio = alxCreateSource( AudioChat, %wav );
//   alxPlay( %audio );
}

function BuyVehicle(%vehicleType, %team)
{
   if ($PilotDontBuy == 1)
	return;

   if ($VehicleTotalCount[%team, %vehicleType] > ($Vehiclemax[%vehicleType]-2))	
   {
	//Leave at least 1 Vehicle of a type available at all times
	AIPilotTask::echo ("Werewolf: ERROR, too many vehicles already in the field");
	return;
   }
   for(%i = 0; $MyPadList[%i] !$=""; %i++)
   {
	if($MyPadList[%i] == 0)
		break;

	if(isObject($MyPadList[%i]))
      {
         if($MyPadList[%i].team == %team)
         {
            %position = $MyPadList[%i].position;
            // ZOD 2-5-03: Setup the proper rotation based on the pads
            %xform = $MyPadList[%i].getSlotTransform(0);
            %rotation = getWords(%xform, 3, 5);
            %angle = (getWord(%xform, 6) + getWord(%xform, 6)) / 3.14159;
            %pad = %i;
         }
      }
   }
   //No vehicle pads at all? Then abort
   if(%i == 0)
	return;

   %mask = $TypeMasks::PlayerObjectType | $TypeMasks::VehicleObjectType | $TypeMasks::TurretObjectType;
   InitContainerRadiusSearch(%position, 20, %mask);
   if( (containerSearchNext() != 0) ) // || ($PadHasVehicle[%pad]) )
   {
	AIPilotTask::echo ("Werewolf: ERROR, vehicle spawn location is blocked");
	return;
   }
   if (%vehicleType $= "ScoutVehicle" || %vehicleType $= "AssaultVehicle")
   {
      %vehicle = new HoverVehicle() 
      {
         dataBlock  = %vehicleType;
         position = getWord(%position,0) @ " " @ getWord(%position,1) @ " " @ getWord(%position,2)+10;
         rotation = %rotation @ " " @ %angle;
         scale = "1 1 1";
         lockCount = "0";
         homingCount = "0";
         team = %team;
      };
   }
   if (%vehicleType $= "MobileBaseVehicle")
   {
      %vehicle = new WheeledVehicle() 
      {
         dataBlock  = %vehicleType;
         position = getWord(%position,0) @ " " @ getWord(%position,1) @ " " @ getWord(%position,2)+10;
         rotation = %rotation @ " " @ %angle;
         scale = "1 1 1";
         lockCount = "0";
         homingCount = "0";
         team = %team;
      };
   }
   if (%vehicleType $= "ScoutFlyer" || %vehicleType $= "BomberFlyer" || %vehicleType $= "HAPCFlyer")
   {
      %vehicle = new FlyingVehicle() 
      {
         dataBlock  = %vehicleType;
         position = getWord(%position,0) @ " " @ getWord(%position,1) @ " " @ getWord(%position,2)+10;
         rotation = %rotation @ " " @ %angle;
         scale = "1 1 1";
         lockCount = "0";
         homingCount = "0";
         team = %team;
         teamBought = %team;
      };
   }
   if (!isObject(%vehicle))
   {
      AIPilotTask::echo("Error: No Vehicle created!");
      return;
   }
   AIPilotTask::echo("VehicleID=" @ %vehicle);
   setTargetSensorGroup(%vehicle.getTarget(), %team); // this flags the vehicle as belonging to the %team
   %vehicle.startFade(1000, 0, false);
   vehicleListAdd(%vehicleType, %vehicle);
   MissionCleanup.add(%vehicle);
   $PadHasVehicle[%pad] = %vehicle;
}


function FreeSeats(%vehicle)
{
   if(isObject(%vehicle))
   {
      %seats = 0;
      if (%vehicle.getMountNodeObject(0))
         %seats++;
      if (%vehicle.getMountNodeObject(1))
         %seats++;
      if (%vehicle.getMountNodeObject(2))
         %seats++;
      if (%vehicle.getMountNodeObject(3))
         %seats++;
      if (%vehicle.getMountNodeObject(4))
         %seats++;
      if (%vehicle.getMountNodeObject(5))
         %seats++;
      if (%vehicle.getMountNodeObject(6))
         %seats++;

      return %seats;
   }
}

function AIPilotTask::echo(%client, %str)
{
   if ($PilotDebug)
      echo (%client @ " " @ %str);
}

function AIPilotTask::init(%task, %client)
{
   AIPilotTask::echo(%client, "PILOT: Init");
}

function AIPilotTask::assume(%task, %client)
{
   AIPilotTask::echo(%client, "PILOT: Assume");
   %task.setWeightFreq(30);
   %task.setMonitorFreq(10);
   %task.locationIndex = -1;
   %task.definePath = 1;
   %client.pilotVehicle = false;
   %client.usingVehicle = false;
}

function AIPilotTask::retire(%task, %client)
{
   AIPilotTask::echo(%client, "PILOT: Retire");
// %client.pilotTask = %client.addTask(AIPilotTask);
}


//-------------------------------------------------------------------------
// The whole wheighting function is responsible for checking whether we
// actually WANT to fly in a vehicle. It sets up all the target and movement
// too, and then hands over to the monitoring function below.
//-------------------------------------------------------------------------
function AIPilotTask::weight(%task, %client)
{
   AIPilotTask::echo(%client, "PILOT: Weight");

   //-------------------------------------------------------------------------
   // This block is for when we have a vehicle or are on our way to it.
   // It has to check for whether someone took our vehicle, and look for a new one in that case.
   //-------------------------------------------------------------------------
   if(%client.usingVehicle)
   {
      // If the vehicle gets destroyed before we get to it, don't bother..
      if (!isObject(%client.pilotTask.vehicle))
      {
         %task.definePath = 1;
         %client.pilotVehicle = false;
         %client.usingVehicle = false;
         %task.setWeight(0);
         %client.pilotTask.vehicle = 0;
         AIPilotTask::echo(%client, "PILOT: Vehicle Destroyed. Flight cancelled.");
         AIDisembarkVehicle(%client);
         return;
      }
      if (%client.usingVehicle)
			return;

		if (!%client)
			return;

		if (!%client.pilotTask.vehicle)
			return;
      // else we're already flying, or on our way to the vehicle...
      //Has someone taken our vehicle in the meantime?
      %pilot = %client.pilotTask.vehicle.getMountNodeObject(0);
      if (!isObject(%client.vehicleMounted)) //This part is only interesting if we're not already mounted...
      {
         if (%pilot > 0 || AIClientIsAlive(%pilot.client))
         {
            // find a new vehicle. This code is duplicated from the inital "search for vehicle"-code somewhere below.
            %client.pilotTask.vehicle = 0;
            %closestDist = 200;
            for (%i = 0; $MyVehicleList[%i] !$= ""; %i++)
            {
               if ($MyVehicleList[%i] == 0)
                  continue;

               %vehicle = $MyVehicleList[%i];
               if (!isObject(%vehicle))
                  continue;

               //Don't pilot if we want to place turrets and stuff
               %pack = %client.player.getMountedImage($BackpackSlot);
               if(%pack.isLarge)
               {
                  AIPilotTask::echo(%client, "I won't pilot because I have a huge backpack");
                  continue;
               }
               // Don't EVER drive a MPB
               if (%vehicle.getDataBlock().getName() $= "MobileBaseVehicle")
                  continue;

               %pilot = %vehicle.getMountNodeObject(0);
               //Check for unpiloted vehicles
               if ((%pilot == 0) || (!AIClientIsAlive(%pilot.client)))
               {
                  // Heavies never pilot
                  if (%client.player.getArmorSize() $= "Heavy")
                     continue;

                  // Mediums don't pilot GravBikes
                  if ( (%client.player.getArmorSize() $= "Medium") && (%vehicle.getDataBlock().getName() $= "ScoutVehicle") )
                     continue;

			// I have commented out the following code because I want bots to use HAPCFlyers, Bombers,
			// and tanks even without passengers.  I have changed it so that they wait 20 seconds
			// before taking off (to wait for passengers), instead.  --Cessen Lynx

			// Don't pilot a havoc if it doesn't have a passenger
			//if (%vehicle.getDataBlock().getName() $= "HAPCFlyer")
			//	if( (%vehicle.getMountNodeObject(1) <= 0) &&
			//	 (%vehicle.getMountNodeObject(2) <= 0) &&
			//	 (%vehicle.getMountNodeObject(3) <= 0) &&
			//	 (%vehicle.getMountNodeObject(4) <= 0) &&
			//	 (%vehicle.getMountNodeObject(5) <= 0) )
			//{
			//	AIPilotTask::echo(%client, "PILOT: Discarded HAPCFlyer");
			//	continue;
			//}

			// Don't pilot a bomber if it doesn't have a canonier
			// if (%vehicle.getDataBlock().getName() $= "BomberFlyer")
			//	if( (%vehicle.getMountNodeObject(1) <= 0) &&
			//	 (%vehicle.getMountNodeObject(2) <= 0) )
			//{
			//	AIPilotTask::echo(%client, "PILOT: Discarded BomberFlyer");
			//	continue;
			//}

			// Don't drive a tank if it doesn't have a canonier
			//if (%vehicle.getDataBlock().getName() $= "AssaultVehicle")
			//	if (%vehicle.getMountNodeObject(1) <= 0)
			//{
			//	AIPilotTask::echo(%client, "PILOT: Discarded AssaultVehicle");
			//	continue;
			//}
               }
               else //We have a pilot there, so don't pilot but check if maybe we want to hitch a ride
               {
                  // These don't have any other seats...
                  if (%vehicle.getDataBlock().getName() $= "MobileBaseVehicle")
                     continue;

                  if (%vehicle.getDataBlock().getName() $= "ScoutVehicle")
                     continue;

                  if (%vehicle.getDataBlock().getName() $= "ScoutFlyer")
                     continue;

                  //Only hitch in tanks if we're not heavy
                  if (%vehicle.getDataBlock().getName() $= "AssaultVehicle") {
                     if ((%vehicle.getMountNodeObject(1) <= 0) || (%client.player.getArmorSize() $= "Heavy"))
                     {
                        AIPilotTask::echo(%client, "HITCH: Discarded AssaultVehicle");
                        continue;
                     }
                  }
                  if (%vehicle.getDataBlock().getName() $= "BomberFlyer") {
                     if ( ((%vehicle.getMountNodeObject(1) <= 0) && (FreeSeats(%vehicle) == 1) && (%client.player.getArmorSize() $= "Heavy")) || (FreeSeats(%vehicle) == 0) )
                     {
                        AIPilotTask::echo(%client, "HITCH: Discarded AssaultVehicle");
                        continue;
                     }
                  }
                  if (%vehicle.getDataBlock().getName() $= "HAPCFlyer") {
                     if (FreeSeats(%vehicle) == 0)
                     {
                        AIPilotTask::echo(%client, "HITCH: Discarded HAPCFlyer");
                        continue;
                     }
                  }
               }
               AIPilotTask::echo(%client, "PILOT: Vehicle " @ %vehicle @ " fits search pattern");
               //see if it's the closest
               %clientPos = %client.player.getWorldBoxCenter();
               %vehiclePos = %vehicle.getWorldBoxCenter();
               %dist = VectorDist(%clientPos, %vehiclePos);
               if (%dist < %closestDist)
               {
                  AIPilotTask::echo(%client, "PILOT: Found Vehicle at dist=" @ %dist);
                  %client.pilotTask.vehicle = %vehicle;
                  %closestDist = %dist;
               }
            }
            // We didn't find anything to pilot, so exit
            if (%client.pilotTask.vehicle == 0)
            {
               AIPilotTask::echo(%client, "PILOT: No Vehicle found");
               if (%client.player.isMounted)
				{
					AIDisembarkVehicle(%client); //Hop off...
				}
               %client.clearStep();
               %client.stepMove(%client.pilotTask.resumePosition, 0.25); //Resume walking to our objective
               %task.definePath = 1;
               %task.setWeight(0);

               //If we're in light or medium armor, maybe we can buy the vehicle ourselves?
               if((%client.player.getArmorSize() $= "Light") || (%client.player.getArmorSize() $= "Medium"))
               {
                  %random = mFloor(getRandom(1, 6)); // ZOD 2-6-03: Make a random purchase
                  if(%random == 1)
                     BuyVehicle(ScoutFlyer, %client.team);
                  else if(%random == 2)
                     BuyVehicle(ScoutVehicle, %client.team);
                  else if(%random == 3)
                     BuyVehicle(ScoutFlyer, %client.team);
                  else if(%random == 4)
                     BuyVehicle(ScoutVehicle, %client.team);
                  else if(%random == 5)
                     BuyVehicle(ScoutFlyer, %client.team);
                  else
                     BuyVehicle(ScoutVehicle, %client.team);
               }
               return;
            }
            else
            {
               // The X and Y distances from the vehicle starting position to the target.
               // Used for plotting waypoints between the target and the starting position
               %xdist = (firstWord(%task.currentTarget) - firstWord(%client.pilotTask.vehicle.position));
               %ydist = (getWord(%task.currentTarget, 1) - getWord(%client.pilotTask.vehicle.position, 1));

               //%client.pilotTask.TestPilotHeadings[0] = (firstWord(%client.pilotTask.vehicle.position) - (xdist / 8)) @ " " @ (getWord(%client.pilotTask.vehicle.position, 1) - (ydist / 8)) @ " " @ (getWord(%client.pilotTask.vehicle.position, 2) + 100);
               //%client.pilotTask.TestPilotHeadings[1] = (firstWord(%task.currentTarget) + (xdist / 8)) @ " " @ (getWord(%task.currentTarget, 1) + (ydist / 8)) @ " " @ (getWord(%task.currentTarget, 2) + 150);
               //%client.pilotTask.TestPilotHeadings[2] = firstWord(%task.currentTarget) @ " " @ getWord(%task.currentTarget, 1) @ " " @ (getWord(%task.currentTarget, 2) + 50);
               //%client.pilotTask.TestPilotHeadings[3] = "";

               %client.pilotTask.TestPilotHeadings[0] = firstWord(%task.currentTarget) @ " " @ getWord(%task.currentTarget, 1) @ " " @ getWord(%task.currentTarget, 2);
               %client.pilotTask.TestPilotHeadings[1] = "";
            }
         }
         AIPilotTask::echo(%client, "PILOT: Already flying. End wheight.");
         %task.setWeight(10000);
         return;
      }
   }
   //-------------------------------------------------------------------------
   // Now comes the part where we check if we should pilot a vehicle.
   // First: Is the player alive?
   //-------------------------------------------------------------------------
   %player = %client.player;
   if (!isObject(%player))
   {
      %task.setWeight(0);
      return;
   }
   //-------------------------------------------------------------------------
   // Check for SAM fodder ;)
   //-------------------------------------------------------------------------

// if ((%client.player.getInventory(MissileLauncher) > 0) && (%client.player.getInventory(MissileLauncherAmmo) > 0))
// {
      if ((%client.pilotTask.target == -1) || (%client.pilotTask.target == 0) || (%client.pilotTask.target $= ""))
      {
         //No missile target, go look for one
//		echo(%client @ " SAM: No missile target, searching...");

         %clientPos = %client.player.getWorldBoxCenter();
         %farthestDist = 300;
         for (%i = 0; $MyVehicleList[%i] !$= ""; %i++)
         {
            if ($MyVehicleList[%i] == 0)
               continue;

            %vehicle = $MyVehicleList[%i];
            if (!isObject(%vehicle))
               continue;

            %vehiclePos = %vehicle.getWorldBoxCenter();
            %dist = VectorDist(%clientPos, %vehiclePos);
            if ((%dist < %farthestDist) && (%client.team != %vehicle.team))
            {
               //echo(%client @ " SAM: Found enemy Vehicle at dist=" @ %dist);
               %client.pilotTask.target = %vehicle;
            }
         }
         //We found a target for the missile
         if ((%client.pilotTask.target != -1) && (%client.pilotTask.target != -1) && (%client.pilotTask.target !$= ""))
         {
            //echo(%client @ " SAM: Firing at target!");
            %player.setInventory(MissileLauncher, 1);
            %player.setInventory(MissileLauncherAmmo, 99);
            %client.player.use(MissileLauncher);
            MissileDudeAimAtTarget(%client, 0);
            //schedule($MissileLauncherAimTime, 0, "MissileDudeFireMissile", %client);
         }
      }
      else
      {
         if (isObject(%client.pilotTask.target))
         {
            //echo(%client @ " SAM: Re-checking distance");
            //we already have a missile target, keep checking whether it's still in range
            %clientPos = %client.player.getWorldBoxCenter();
            %vehiclePos = %client.pilotTask.target.getWorldBoxCenter();
            %dist = VectorDist(%clientPos, %vehiclePos);
            if (%dist >= 300)
               %client.pilotTask.target = -1;
         }
         else
            %client.pilotTask.target = -1;
      }
//}
   //-------------------------------------------------------------------------
   // Check for the bot's objective target.
   //-------------------------------------------------------------------------
   //Get our target client's pos
   %targetClient = %client.shouldEngage;
   if (AIClientIsAlive(%targetClient)) //No client as target? Then go to the patrol target...
   {
      %task.currentTarget = %targetClient.player.getWorldBoxCenter();
      AIPilotTask::echo(%client, "PILOT: Target: Client " @ %targetClient);
   }
   else if (%client.patrolLocation !$= "")
   {
      %task.currentTarget = %client.patrolLocation;
      AIPilotTask::echo(%client, "PILOT: Target: Patrol Task");
   }
   else if (%client.turretLocation !$= "")
   {
      %task.currentTarget = %client.turretLocation;
      AIPilotTask::echo(%client, "PILOT: Target: Turret Task");
   }
   else if (%client.flagLocation !$= "")
   {
      %task.currentTarget = %client.flagLocation;
      AIPilotTask::echo(%client, "PILOT: Target: Flag Task");
   }
   else if (%client.objective > 0)
   {
      if (isObject(%client.objective))
      {
         %task.currentTarget = %client.objective.getWorldBoxCenter();
         AIPilotTask::echo(%client, "PILOT: Target: Generic Objective; isObject");
      }
      else
      {
         %task.currentTarget = %client.objective.location;
         AIPilotTask::echo(%client, "PILOT: Target: Generic Objective; NOT isObject");
      }
   }
   if (%client.needEquipment)
   {
      %task.currentTarget = -1;
      AIPilotTask::echo(%client, "PILOT: Target scrapped due to inventory buying!");
   }

   //If there's no target pos, or the pos is not far enough, don't use a vehicle at all
   %clientPos = %client.player.getWorldBoxCenter();
   if ( (%task.currentTarget == -1) || (%task.currentTarget $= "") || (VectorDist(%clientPos, %task.currentTarget) < 350) )
   {
      AIPilotTask::echo(%client, "Distance: " @ %client.getPathDistance(%task.currentTarget));
      AIPilotTask::echo(%client, "PILOT: No Target. End.");
       if ( %client.player.isMounted() )
        	{
			AIDisembarkVehicle(%client); //Hop off...
            }
      %task.setWeight(0);
      return;
   }
   else
   {
      AIPilotTask::echo(%client, "PILOT: Target position: " @ %task.currentTarget);
      %client.pilotTask.resumePosition = %task.currentTarget;
   }
   //-------------------------------------------------------------------------
   // Ok now that we have a target, look for a new and unpiloted vehicle!
   // Note that this is exactly the same code as above.
   //-------------------------------------------------------------------------
   %client.pilotTask.vehicle = 0;

   //loop through the vehicle set, looking for unpiloted vehicles in a 300 units radius...
   %closestDist = 300;

   //search for scout bikes, flyers or tanks
   for (%i = 0; $MyVehicleList[%i] !$= ""; %i++)
   {
      if ($MyVehicleList[%i] == 0)
         continue;

      %vehicle = $MyVehicleList[%i];
      if (!isObject(%vehicle))
         continue;

      //Don't pilot if we want to place turrets and stuff
      %pack = %client.player.getMountedImage($BackpackSlot);
      if(%pack.isLarge)
      {
         AIPilotTask::echo(%client, "I won't pilot because I have a huge backpack");
         continue;
      }
      // Don't EVER drive a MPB
      if (%vehicle.getDataBlock().getName() $= "MobileBaseVehicle")
         continue;

      %pilot = %vehicle.getMountNodeObject(0);
      //Check for unpiloted vehicles
      if ((%pilot == 0) || (!AIClientIsAlive(%pilot.client)))
      {
         // Heavies never pilot
         if (%client.player.getArmorSize() $= "Heavy")
         {
            AIPilotTask::echo(%client, "I won't pilot because I am a heavy");
            continue;
         }
         // Mediums don't pilot GravBikes
         if ( (%client.player.getArmorSize() $= "Medium") && (%vehicle.getDataBlock().getName() $= "ScoutVehicle") )
         {
            AIPilotTask::echo(%client, "I won't pilot because mediums and Bikes don't mix");
            continue;
         }
		// I have commented out the following code because I want bots to use HAPCFlyers, Bombers,
		// and tanks even without passengers.  I have changed it so that they wait 20 seconds
		// before taking off (to wait for passengers), instead.  --Cessen Lynx

		// Don't pilot a havoc if it doesn't have a passenger
		//if (%vehicle.getDataBlock().getName() $= "HAPCFlyer")
		//	if( (%vehicle.getMountNodeObject(1) <= 0) &&
		//	 (%vehicle.getMountNodeObject(2) <= 0) &&
		//	 (%vehicle.getMountNodeObject(3) <= 0) &&
		//	 (%vehicle.getMountNodeObject(4) <= 0) &&
		//	 (%vehicle.getMountNodeObject(5) <= 0) )
		//{
		//	AIPilotTask::echo(%client, "PILOT: Discarded HAPCFlyer");
		//	continue;
		//}

		// Don't pilot a bomber if it doesn't have a canonier
		// if (%vehicle.getDataBlock().getName() $= "BomberFlyer")
		//	if( (%vehicle.getMountNodeObject(1) <= 0) &&
		//	 (%vehicle.getMountNodeObject(2) <= 0) )
		//{
		//	AIPilotTask::echo(%client, "PILOT: Discarded BomberFlyer");
		//	continue;
		//}

		// Don't drive a tank if it doesn't have a canonier
		//if (%vehicle.getDataBlock().getName() $= "AssaultVehicle")
		//	if (%vehicle.getMountNodeObject(1) <= 0)
		//{
		//	AIPilotTask::echo(%client, "PILOT: Discarded AssaultVehicle");
		//	continue;
		//}
      }
      else //We have a pilot there, so don't pilot but check if maybe we want to hitch a ride
      {
         // These don't have any other seats...
         if (%vehicle.getDataBlock().getName() $= "MobileBaseVehicle")
            continue;
         if (%vehicle.getDataBlock().getName() $= "ScoutVehicle")
            continue;
         if (%vehicle.getDataBlock().getName() $= "ScoutFlyer")
            continue;
         //Only hitch in tanks if we're not heavy
         if (%vehicle.getDataBlock().getName() $= "AssaultVehicle")
         {
            if ((%vehicle.getMountNodeObject(1) <= 0) || (%client.player.getArmorSize() $= "Heavy"))
            {
               AIPilotTask::echo(%client, "HITCH: Discarded AssaultVehicle");
               continue;
            }
         }
         if (%vehicle.getDataBlock().getName() $= "BomberFlyer")
         {
            if(((%vehicle.getMountNodeObject(1) <= 0) && (FreeSeats(%vehicle) == 1) && (%client.player.getArmorSize() $= "Heavy")) || (FreeSeats(%vehicle) == 0))
            {
               AIPilotTask::echo(%client, "HITCH: Discarded AssaultVehicle");
               continue;
            }
         }
         if (%vehicle.getDataBlock().getName() $= "HAPCFlyer")
         {
            if (FreeSeats(%vehicle) == 0)
            {
               AIPilotTask::echo(%client, "HITCH: Discarded HAPCFlyer");
               continue;
            }
         }
      }
      AIPilotTask::echo(%client, "PILOT: Vehicle " @ %vehicle @ " fits search pattern");
      //see if it's the closest
      %clientPos = %client.player.getWorldBoxCenter();
      %vehiclePos = %vehicle.getWorldBoxCenter();
      %dist = VectorDist(%clientPos, %vehiclePos);
      if (%dist < %closestDist)
      {
         AIPilotTask::echo(%client, "PILOT: Found Vehicle at dist=" @ %dist);
         %client.pilotTask.vehicle = %vehicle;
         %closestDist = %dist;
      }
   }
   // We didn't find anything to pilot, so exit
   if (%client.pilotTask.vehicle == 0 &&
		!%client.player.isMounted() )
   {
      AIPilotTask::echo(%client, "PILOT: No Vehicle found");
      AIDisembarkVehicle(%client); //Hop off...
      %task.definePath = 1;
      %task.setWeight(0);

      //If we're in light or medium armor, maybe we can buy the vehicle ourselves?
      if((%client.player.getArmorSize() $= "Light") || (%client.player.getArmorSize() $= "Medium"))
      {
         %random = mFloor(getRandom(1, 6)); // ZOD 2-6-03: Make a random purchase
         if(%random == 1)
            BuyVehicle(ScoutFlyer, %client.team);
         else if(%random == 2)
            BuyVehicle(ScoutVehicle, %client.team);
         else if(%random == 3)
            BuyVehicle(ScoutFlyer, %client.team);
         else if(%random == 4)
            BuyVehicle(ScoutVehicle, %client.team);
         else if(%random == 5)
            BuyVehicle(ScoutFlyer, %client.team);
         else
            BuyVehicle(ScoutVehicle, %client.team);
      }
      return;
   }
   //Hey, there's a nearby vehicle, so setup the pilot/passenger
   AIPilotTask::echo(%client, "PILOT: Using Vehicle that's " @ %closestDist @ " units away!");
   %client.usingVehicle = true;

   %pilot = %client.pilotTask.vehicle.getMountNodeObject(0);
   if ((%pilot == 0) || (!AIClientIsAlive(%pilot.client)))
   {
      AIPilotTask::echo(%client, "PILOT: I'm pilot, Yay!");
      %client.pilotVehicle = true;
      %task.definePath = 1;
   }
   else
   {
      AIPilotTask::echo(%client, "HITCH: I'm just hitching a ride here...");
      %task.definePath = 0;
   }
   //-------------------------------------------------------------------------
   // Now the vehicle is found, and we can set the navigation data.
   // Note: This is the point where most improvements should be made, as
   // the bot takes a straight route from the vehicle's pos to the target.
   //-------------------------------------------------------------------------
   if (%task.definePath)
   {
      AIPilotTask::echo(%client, "PILOT: Defining Path...");
      %task.definePath = 0;

      // The X and Y distances from the vehicle starting point to the target.
      // Used for plotting waypoints at places between the target and the starting position
      %xdist = (firstWord(%task.currentTarget) - firstWord(%client.pilotTask.vehicle.position));
      %ydist = (getWord(%task.currentTarget, 1) - getWord(%client.pilotTask.vehicle.position, 1));

      // Set the way-points of the botpilots route
      //%client.pilotTask.TestPilotHeadings[0] = (firstWord(%client.pilotTask.vehicle.position) - (xdist / 8)) @ " " @ (getWord(%client.pilotTask.vehicle.position, 1) - (ydist / 8)) @ " " @ (getWord(%client.pilotTask.vehicle.position, 2) + 100);
      //%client.pilotTask.TestPilotHeadings[1] = (firstWord(%task.currentTarget) + (xdist / 8)) @ " " @ (getWord(%task.currentTarget, 1) + (ydist / 8)) @ " " @ (getWord(%task.currentTarget, 2) + 150);
      //%client.pilotTask.TestPilotHeadings[2] = firstWord(%task.currentTarget) @ " " @ getWord(%task.currentTarget, 1) @ " " @ (getWord(%task.currentTarget, 2) + 50);
      //%client.pilotTask.TestPilotHeadings[3] = "";

      %client.pilotTask.TestPilotHeadings[0] = firstWord(%task.currentTarget) @ " " @ getWord(%task.currentTarget, 1) @ " " @ getWord(%task.currentTarget, 2);
      %client.pilotTask.TestPilotHeadings[1] = "";
   }
   //-------------------------------------------------------------------------
   // All set, now walk towards the vehicle
   //-------------------------------------------------------------------------
   %client.clearStep();
   %client.stepMove(%client.pilotTask.vehicle.position, 0.25, $AIModeMountVehicle);

   //make sure the pilot is in light, and doesn't have an backpacks...
   //%client.player.throwPack();
   //%client.player.setArmor(Light);

   %task.setWeight(10000);
   %task.locationIndex = -1;
}


//------------------------------------------------------------------------------------
// This function takes in the current position of a vehicle, it's destination
// and then figures out where the vehicle should go to avoid crashing while
// still heading towards it's destination.  It returns the coordinate that
// the vehicle should head towards.  Note: this function is only for flying vehicles
//------------------------------------------------------------------------------------
function Navigate( %pos, %aim )
{
   %mask = $TypeMasks::TerrainObjectType | $TypeMasks::InteriorObjectType;
	
   // Calculate the vehicles altitude
   %downVect = getWord( %pos, 0 ) @ " " @ getWord( %pos, 1 ) @ " 0";
   %altsurface = containerRayCast( %pos, %downVect, %mask, 0 );

   %altpos = posFromRaycast( %altsurface );
   %altitude = getWord( %pos, 2 ) - getWord( %altpos, 2 );
   // Done calculating the vehicles altitude
   // The %altitude variable (which contains the vehicles altitude may
   // be used in the future for more advanced navigation code

   // Cast a ray towards our destination
   %surface = containerRayCast( %pos, %aim, %mask, 0 );
   if( !%surface ) // It didn't intersect anything
   {
      return %aim; // There's nothing between us and our destination, so let's simply return our destination
   }
   // Get the position and surface normal of the point that the ray intersected
   %ipos = posFromRaycast(%surface); // position
   %inor = normalFromRaycast(%surface); // surface normal
   %idist = VectorDist( %pos, %ipos ); // distance between current position and the intersection point

   if( getWord( %inor, 2 ) > 0 ) // If the surface is aiming upward
   {
      %destn = getWord( %ipos, 0 ) @ " " @ getWord( %ipos, 1 ) @ " " @ (getWord( %ipos, 2 ) + 10 + (5 / getWord( %inor, 2 )));
      return %destn;
   }
   if( getWord( %inor, 2 ) < 0 ) // If the surface is aiming downward
   {
      %destn = getWord( %ipos, 0 ) @ " " @ getWord( %ipos, 1 ) @ " " @ (getWord( %ipos, 2 ) + 128);
      return %destn;
   }
   if( getWord( %inor, 2 ) == 0 ) // If the surface is aiming perfectly sideways
   {
      %destn = getWord( %ipos, 0 ) @ " " @ getWord( %ipos, 1 ) @ " " @ (getWord( %ipos, 2 ) + (128 / %idist));
      return %destn;
   }
   return %aim;
}

//-------------------------------------------------------------------------
// This whole function is only called if the wheighting-function above
// has found and set up all the things for piloting
//-------------------------------------------------------------------------
function AIPilotTask::monitor(%task, %client)
{
   AIPilotTask::echo(%client, "PILOT: Monitor");
   if (!%client.usingVehicle)
      return;

   //-------------------------------------------------------------------------
   // This part handles the walking towards the vehicle.
   //-------------------------------------------------------------------------

   //see if we've mounted yet
   if (%task.locationIndex == -1)
   {
      AIPilotTask::echo(%client, "PILOT: Monitor: Travelling to vehicle");
      //mount the vehicle
      %client.usingVehicle = true;
      %client.stepMove(%client.pilotTask.vehicle.position, 0.25, $AIModeMountVehicle);

      if (isObject(%client.vehicleMounted))
      {
         AIPilotTask::echo(%client, "PILOT: Monitor: Mounted Vehicle!");
         %task.locationIndex++;
         %client.setPilotDestination(%client.pilotTask.TestPilotHeadings[%task.locationIndex]);
         %client.setPilotPitchRange(-0.2, 0.05, 0.05);

         //Check if we activate the turret as passenger
         if (!%client.pilotVehicle)
         {
            if (%client.vehicleMounted.getDataBlock().getName() $= "AssaultVehicle")
            {
               //node 1 is this vehicle's turret seat
               if (%client == %client.vehicleMounted.getMountNodeObject(1))
               {
                  AIPilotTask::echo(%client, "PILOT: Monitor: Controlling Tank Turret!");
                  %turret = %vehicle.getMountNodeObject(10);
                  %skill = %client.getSkillLevel();
                  %turret.setSkill(%skill);
                  %client.turretMounted = %turret;
                  %client.setTurretMounted(%turret);
                  %turret.setAutoFire(true);
               }
            }
            else if (%client.vehicleMounted.getDataBlock().getName() $= "BomberFlyer")
            {
               //node 1 is this vehicle's turret seat
               if (%client == %client.vehicleMounted.getMountNodeObject(1))
               {
                  AIPilotTask::echo(%client, "PILOT: Monitor: Controlling Bomber Turret!");
                  %turret = %vehicle.getMountNodeObject(10);
                  %skill = %client.getSkillLevel();
                  %turret.setSkill(%skill);
                  %client.turretMounted = %turret;
                  %client.setTurretMounted(%turret);
                  %turret.setAutoFire(true);
               }
            }
         }
         //--- End of Turret activation code...
      }
   }
   //-------------------------------------------------------------------------
   // Now we're aboard and fly along our programmed waypoint list towards the target
   //-------------------------------------------------------------------------
   //else see if we're close enough to the current destination to choose the next
   else
   {
      %pos3D = %client.vehicleMounted.position;
      %pos2D = getWord(%pos3D, 0) SPC getWord(%pos3D, 1) SPC "0";
      if (%client.pilotVehicle && isObject(%client.pilotTask.vehicle))
      {
         // If the timer has not been set yet, and we are short on passengers, and we are not yet driving/flying
         if( FreeSeats( %client.pilotTask.vehicle ) > 0 && %task.locationIndex == 0 && %task.waitTimerMS == 0 )
         {
            %task.waitTimerMS = getSimTime();
         }
         %elapsedTime = getSimTime() - %task.waitTimerMS;

         // If the vehicle is full, we are already driving/flying, or our waiting time has elapsed
         if( FreeSeats( %client.pilotTask.vehicle ) == 0 || %task.locationIndex > 0 || (%task.waitTimerMS != 0 && %elapsedTime > $BotPilotWaitTime) )
         {		
            %dest3D = %client.pilotTask.TestPilotHeadings[%task.locationIndex];
            %dest2D = getWord(%dest3D, 0) @ " " @ getWord(%dest3D, 1) @ " 0";

            // If it's a ground vehicle
            if( %client.pilotTask.vehicle.getDataBlock().getName() $= "ScoutVehicle" ||
                %client.pilotTask.vehicle.getDataBlock().getName() $= "AssaultVehicle" ||
                %client.pilotTask.vehicle.getDataBlock().getName() $= "MobileBaseVehicle" )
            {
               // Put ground vehicle update code here
               %client.setPilotDestination( %client.pilotTask.TestPilotHeadings[%task.locationIndex]  );
            }
            else // If it's an air vehicle
            {
               AIPilotTask::echo(%client, "PILOT: Navigate target=" @ %dest3D);
               AIPilotTask::echo(%client, "PILOT: Navigate output=" @ Navigate( %pos3D, %dest3D ) );
               %client.setPilotDestination( Navigate( %pos3D, %dest3D ) );
               //%client.setPilotDestination( %client.pilotTask.TestPilotHeadings[%task.locationIndex]  );
            } 
            AIPilotTask::echo(%client, "PILOT: Monitor: En route");
            if (VectorDist(%dest2D, %pos2D) < 40)
            {
               if (%client.pilotTask.TestPilotHeadings[%task.locationIndex + 1] !$= "")
               {
                  %task.locationIndex++;
                  // If it's a ground vehicle
                  if( %client.pilotTask.vehicle.getDataBlock().getName() $= "ScoutVehicle" ||
                      %client.pilotTask.vehicle.getDataBlock().getName() $= "AssaultVehicle" ||
                      %client.pilotTask.vehicle.getDataBlock().getName() $= "MobileBaseVehicle" )
                  {
                     %client.setPilotDestination( %client.pilotTask.TestPilotHeadings[%task.locationIndex]  );
                  }
                  else // If it's an air vehicle
                  {
                     %client.setPilotDestination( Navigate( %pos3D, %client.pilotTask.TestPilotHeadings[%task.locationIndex] ) );
                     //%client.setPilotDestination( %client.pilotTask.TestPilotHeadings[%task.locationIndex]  );
                  }
                  %client.usingVehicle = true;
                  AIPilotTask::echo(%client, "PILOT: Monitor: Waypoint reached");
               }
               else if (%client.vehicleMounted )
               {
                  %task.definePath = 1;
                  //%client.pilotVehicle = false; // Overridden by DisembarkVehicle
                  AIDisembarkVehicle(%client); //Hop off...
                  %client.usingVehicle = false;
                  %client.clearStep();
                  %client.stepMove(%client.pilotTask.resumePosition, 0.25); //Resume walking to our objective
                  AIPilotTask::echo(%client, "PILOT: Monitor: Reached Target! Hopping off...");
               }
            }
         }
         else // We are still waiting to take-off
         {
            AIPilotTask::echo(%client, "PILOT: Monitor: Waiting for passengers" );
         }
      }
      else // we're just a passenger, check if we're close enough to hop off
      {
         %dest = %client.pilotTask.resumePosition;
         %dest2D = getWord(%dest, 0) @ " " @ getWord(%dest, 1) @ " 0";
         AIPilotTask::echo(%client, "HITCH: Monitor: En route");
         if(isObject(%client.pilotTask.vehicle))
         {
            %pilot = %client.pilotTask.vehicle.getMountNodeObject(0);
            if ( (VectorDist(%dest2D, %pos2D) < 150) || ((%pilot == 0) || (!AIClientIsAlive(%pilot.client))) )
            { //Jump off if we're close or if pilot left for good...
               %task.definePath = 1;
               AIDisembarkVehicle(%client); //Hop off...
               %client.usingVehicle = false;
               %client.clearStep();
               %client.stepMove(%client.pilotTask.resumePosition, 0.25); //Resume walking to our objective
               AIPilotTask::echo(%client, "PILOT: Monitor: Reached Target! Hopping off...");
            }
         }
      }
   }
}
// RevMod2 SP1 05/14/2003
// WAITING FOR PASSENGERS

function botWaitforPassengers(%task, %client)
{
// just schedule a toggle.. much easier

	%client.readytofly = false;
	%client.waitingtofly = true;
	%client.alreadywaitedtofly = false;

	%ticker = $BotPilotWaitTime / 1000;
        messageTeam(%client.team, 'MsgAIPilotWaiting', '\c3BotPilot %1 is waiting %2 seconds for passengers.',%client.name, %ticker);


warn (%client, " GONNA WAIT ", $BotPilotWaitTime);
        schedule($BotPilotWaitTime, 0, "botReadyFlyNow", %task, %client);

//	return;
}


function botReadyFlyNow(%task, %client)
{
echo (%client, " IS READY TO FLY");

	%client.readytofly = true;
	%client.waitingtofly = false;
	%client.alreadywaitedtofly = true;
//	return;
}
