//--------------------------------------------------------------------------------------- AIO Repair Object ---
//if you have a problem with bot getting stuck navigating to repair any object,
//place objective marker in spot you want bot to stand for repair at about bots waist level.
//if there is no problem with bot getting stuck repairing this object set the AIORepairObject
//markers transform to the same exact transform as the Object (x, y, z) updated - 10-18-2003

//fixed spam error when trying to repair a deployed object in case it gets destroyed while
//in loop. also fixed bots finding repair pack if base is down :) ----------- Lagg... 3-26-2003

function AIORepairObject::weight(%this, %client, %level, %minWeight, %inventoryStr)
{
   // if were playing CnH, check who owns this
   if (!isObject(%this.targetObjectId) || %this.targetObjectId.isHidden() || %this.targetObjectId.team != %client.team)
      return 0;      
   
   //make sure the player is still alive!!!!!
   if (! AIClientIsAlive(%client))
      return 0;
      
   //no need to repair if the object isn't in need
   if (!isObject(%this.targetObjectId) || %this.targetObjectId.getDamagePercent() <= 0)
      return 0;
   else
	{
		//if this bot is linked to a human who has issued this command, up the weight
		if (%this.issuedByClientId == %client.controlByHuman)
		{
			//make sure we have the potential to reach the minWeight
			if (!AIODefault::QuickWeight(%this, %client, %level, %minWeight))
			{
				if ($AIWeightHumanIssuedCommand < %minWeight)
					return 0;
				else
					%weight = $AIWeightHumanIssuedCommand;
			}
			else
			{
				// calculate the default...
				%weight = AIODefault::weight(%this, %client, %level, %inventoryStr);
				if (%weight < $AIWeightHumanIssuedCommand)
					%weight = $AIWeightHumanIssuedCommand;
			}
		}
		else
		{
			//make sure we have the potential to reach the minWeight
			if (!AIODefault::QuickWeight(%this, %client, %level, %minWeight))
				return 0;

			// calculate the default...
			%weight = AIODefault::weight(%this, %client, %level, %inventoryStr);
		}

		return %weight;
	}
}

function AIORepairObject::assignClient(%this, %client)
{
   %client.objectiveTask = %client.addTask(AIRepairObject);
   %client.objectiveTask.initFromObjective(%this, %client);
}

function AIORepairObject::unassignClient(%this, %client)
{
   %client.removeTask(%client.objectiveTask);
   %client.objectiveTask = "";
}

//----------------------------------------------------------------------------------------------- AI Repair Object ---

function AIRepairObject::initFromObjective(%task, %objective, %client)
{
   %task.baseWeight = %client.objectiveWeight;
   %task.targetObject = %objective.targetObjectId;
	//need to force this objective to only require a repair pack
   //%task.equipment = %objective.equipment;
   %task.equipment = "RepairPack";
	%task.buyEquipmentSet = %objective.buyEquipmentSet;
	%task.desiredEquipment = %objective.desiredEquipment;
	%task.issuedByClient = %objective.issuedByClientId;
        %task.location = %objective.location;
        
	%task.deployed = %objective.deployed;
	if (%task.deployed)
	{
                if (!isObject(%task.targetObject) && isObject(%objective.repairObjective))
		{
                    //if this task is the objective task, choose a new objective
                    if (%task == %client.objectiveTask)
		    {
                        AIUnassignClient(%client);
	                Game.AIChooseGameObjective(%client);			
		    }
                    return;                    
	        }
		%task.location = %objective.position;
		%task.deployDirection = MatrixMulVector("0 0 0 " @ getWords(%objective.getTransform(), 3, 6), "0 1 0");
		%task.deployDirection = VectorNormalize(%task.deployDirection);
	}
}

function AIRepairObject::assume(%task, %client)
{
   %task.setWeightFreq(15);
   %task.setMonitorFreq(15);
   %client.needEquipment = AINeedEquipment(%task.equipment, %client);
      
   //clear the target object, and range it
   %client.setTargetObject(-1);
	if (! %client.needEquipment)
	{
	    if (%task.deployed)
	    {
                if (!isObject(%task.targetObject) && isObject(%objective.repairObjective))
		{
                    //if this task is the objective task, choose a new objective
                    if (%task == %client.objectiveTask)
		    {
                        AIUnassignClient(%client);
	                Game.AIChooseGameObjective(%client);			
		    }
		    return;                    
	        }
		   %task.repairLocation = VectorAdd(%task.location,VectorScale(%task.deployDirection, -4.0));//was -4
			%client.stepMove(%task.repairLocation, 0.25);
	    }

            //if the objective marker was moved than we have a problemed target
            //and we move to the objective marker to fix bot getting stuck trying
            //to repair object - Lagg... 10-10-2003            
            else if (%task.targetObject.getWorldBoxCenter() == %task.location)
                %client.stepRangeObject(%task.targetObject, "DefaultRepairBeam", 2, 4);                    
            else
	        %client.stepMove(%task.location);
	}

	//mark the current time for the buy inventory state machine
	%task.buyInvTime = getSimTime();
	%task.needToRangeTime = 0;
	%task.pickupRepairPack = -1;
	%task.usingInv = false;

	//set a tag to help the repairPack.cs script fudge acquiring a target
	%client.repairObject = %task.targetObject;

        //--------------------------------------------------- assume telporter - start -
        //if the MPB Teleporter is online - Lagg... 9-30-2003

        //first check for deployed MPB
//        %result = AIFindDeployedMPB(%client);//new function in aiVehicle.cs
//        %closestMPB = getWord(%result, 0);
//        %closestMPBDist = getWord(%result, 1);
//      
//        //next find the teleporter
//        %result = SweepForTeleporters(%client);//new function in aiVehicle.cs
//        %closestTel = getWord(%result, 0);
//        %closestTelDist = getWord(%result, 1);
//      
//       //now check for what would be closer - Lagg... 10-1-2003
//       if (%closestMPB > 0 && %closestTel > 0)
//       {
//          %disToTarg = %client.getPathDistance(%task.targetObject.getTransform());
//          %mpbDisToTarg = vectorDist(%closestMPB.getTransform(), %task.targetObject.getTransform());
//         
//          if (%closestTelDist < %closestMPBDist && %closestMPBDist < %disToTarg && %mpbDisToTarg < %disToTarg)
//             %task.useTeleport = true;//new - Lagg... 10-1-2003
//          else
//             %task.useTeleport = false;             
//       }
//--------------------------------------------------- assume telporter - end -
}

function AIRepairObject::retire(%task, %client)
{
   %client.setTargetObject(-1);
	%client.repairObject = -1;
}

function AIRepairObject::weight(%task, %client)
{
        //update the task weight
	if (%task == %client.objectiveTask)
		%task.baseWeight = %client.objectiveWeight;

   //let the monitor decide when to stop repairing
   %task.setWeight(%task.baseWeight);
}

function AIRepairObject::monitor(%task, %client)
{
   //echo("AIRepairObject --- monitor");
   //first, buy the equipment
   if (%client.needEquipment)
   {
           %task.setMonitorFreq(5);

		//first, see if we still need a repair pack
		if (%client.player.getInventory(RepairPack) > 0)
		{
			%client.needEquipment = false;
		   %task.setMonitorFreq(15);

			//if this is to repair a deployed object, walk to the deploy point...
			if (%task.deployed)
			{
                           if (!isObject(%task.targetObject) && isObject(%objective.repairObjective))
		           {
                               %client.setTargetObject(-1);
                               //if this task is the objective task, choose a new objective
                               if (%task == %client.objectiveTask)
		               {
                                  //AIUnassignClient(%client);
	                          //Game.AIChooseGameObjective(%client);			
		               }
		               AIClearObjective(%objective.repairObjective);
		               %objective.repairObjective.delete();
		               %objective.repairObjective = "";
                               clearObjectiveFromTable(%objective.repairObjective);//new function below to stop objective spam - Lagg... 1-27-2004
                               echo("AIRepairObject - DOES THIS GET CALLED AT ALL it is an error you know init - is not an object so delete repairobjective");
                               return;                    
	                   }
			   %task.repairLocation = VectorAdd(%task.location,VectorScale(%task.deployDirection, -4.0));//was -4
				%client.stepMove(%task.repairLocation, 0.25);
			}
                        //if the objective marker was moved than we have a problemed target
                        //and we move to the objective marker to fix bot getting stuck trying
                        //to repair object - Lagg... 10-10-2003            
                        
                        if (%task.targetObject.getDataBlock().getName() $= "MobileBaseVehicle")
                           %client.stepRangeObject(%task.targetObject, "DefaultRepairBeam", 9, 10);            
                        else if (%task.targetObject.getWorldBoxCenter() == %task.location)
                           %client.stepRangeObject(%task.targetObject, "DefaultRepairBeam", 2, 4);
                        else
	                   %client.stepMove(%task.location);
		}
		else
		{
			// check to see if there's a repair pack nearby
			%closestRepairPack = -1;
			%closestRepairDist = 32767;

			//search the AIItemSet for a repair pack (someone might have dropped one...)
			%itemCount = $AIItemSet.getCount();
			for (%i = 0; %i < %itemCount; %i++)
			{
				%item = $AIItemSet.getObject(%i);
				if (%item.getDataBlock().getName() $= "RepairPack" && !%item.isHidden())
				{
                                        %dist = %client.getPathDistance(%item.getWorldBoxCenter());
					if (%dist > 0 && %dist < %closestRepairDist)
					{
                                                %closestRepairPack = %item;
						%closestRepairDist = %dist;
					}
				}
			}

			//choose whether we're picking up the closest pack, or buying from an inv station...
                        //with all these errors by Dynamix it is a wonder the bots do anything - Lagg... 3-25-2003
			if ((isObject(%closestRepairPack) && %closestRepairPack != %task.pickupRepairPack) || (%task.buyInvTime != %client.buyInvTime))
                        {
                                %task.pickupRepairPack = %closestRepairPack;

				//initialize the inv buying
				%task.buyInvTime = getSimTime();
				AIBuyInventory(%client, "RepairPack", %task.buyEquipmentSet, %task.buyInvTime);

				//now decide which is closer
				if (isObject(%closestRepairPack))
				{
                                        //added a little here to check for power - Lagg... - 3-25-2003
					if (isObject(%client.invToUse) && (%client.invToUse.isEnabled()) && (%client.invToUse.isPowered()))
					{
                                                %dist = %client.getPathDistance(%client.invToUse.getWorldBoxCenter());
						if (%dist < %closestRepairDist)
							%task.usingInv = true;
						else
							%task.usingInv = false;
					}
					else
                                           %task.usingInv = false;
				}
				else
					%task.usingInv = true;
			}

			//now see if we found a closer repair pack
			if (!%task.usingInv)
			{
				%client.stepMove(%task.pickupRepairPack.position, 0.25);
				%distToPack = %client.getPathDistance(%task.pickupRepairPack.position);
				if (%distToPack < 10 && %client.player.getMountedImage($BackpackSlot) > 0)
					%client.player.throwPack();

				//and we're finished until we actually have a repair pack... should now! - Lagg...
				return;
			}
			else
			{
		                %result = AIBuyInventory(%client, "RepairPack", %task.buyEquipmentSet, %task.buyInvTime);
				if (%result $= "InProgress")
                                {
                                   //force a nervous reaction every 15 sec - Lagg...
                                   if (getSimTime() - %task.buyInvTime > 15000)
                                   {
                                      %client.setDangerLocation(%client.player.getWorldBoxCenter(), 15);
                                      %task.buyInvTime = getSimTime();
                                   }
                                   return;
                                }
				else if (%result $= "Finished")
				{
					%client.needEquipment = false;
				        %task.setMonitorFreq(15);

					//if this is to repair a deployed object, walk to the deploy point...
					if (%task.deployed)
					{ 	
					   %task.repairLocation = VectorAdd(%task.location,VectorScale(%task.deployDirection, -6.0));//was -4
						%client.stepMove(%task.repairLocation, 0.25);
					}
                                        //if the objective marker was moved than we have a problemed target
                                        //and we move to the objective marker to fix bot getting stuck trying
                                        //to repair object - Lagg... 10-10-2003

                                        else if (%task.targetObject.getDataBlock().getName() $= "MobileBaseVehicle")
                                           %client.stepRangeObject(%task.targetObject, "DefaultRepairBeam", 9, 10);            
                                        else if (%task.targetObject.getWorldBoxCenter() == %task.location)
                                           %client.stepRangeObject(%task.targetObject, "DefaultRepairBeam", 2, 4);
                                        else
	                                        %client.stepMove(%task.location);
				}
				else if (%result $= "Failed")
				{
			      //if this task is the objective task, choose a new objective
			      if (%task == %client.objectiveTask)
			      {
			         AIUnassignClient(%client);
			         Game.AIChooseGameObjective(%client);
			      }
					return;
				}
			}
		}
   }
	//if we made it past the inventory buying, reset the inv time
	%task.buyInvTime = getSimTime();
   
	//chat
	if (%task.sendMsg)
	{
		if (%task.sendMsgTime == 0)
			%task.sendMsgTime = getSimTime();
		else if (getSimTime() - %task.sendMsgTime > 7000)
		{
			%task.sendMsg = false;
		   if (%client.isAIControlled())
			{
				if (%task.chat !$= "")
				{
					%chatMsg = getWord(%task.chat, 0);
					%chatTemplate = getWord(%task.chat, 1);
					if (%chatTemplate !$= "")
						AIMessageThreadTemplate(%chatTemplate, %chatMsg, %client, -1);
					else
						AIMessageThread(%task.chat, %client, -1);
				}
				else if (%task.targetObject > 0)
				{
					%type = %task.targetObject.getDataBlock().getName();
					if (%type $= "GeneratorLarge")
						AIMessageThreadTemplate("RepairBase", "ChatSelfRepairGenerator", %client, -1);
					else if (%type $= "StationVehicle")
						AIMessageThreadTemplate("RepairBase", "ChatSelfRepairVehicle", %client, -1);
					else if (%type $= "SensorLargePulse")
						AIMessageThreadTemplate("RepairBase", "ChatSelfRepairSensors", %client, -1);
					else if (%type $= "SensorMediumPulse")
						AIMessageThreadTemplate("RepairBase", "ChatSelfRepairSensors", %client, -1);
					else if (%type $= "TurretBaseLarge")
						AIMessageThreadTemplate("RepairBase", "ChatSelfRepairTurrets", %client, -1);
				}
			}
		}
	}

   //--------------------------------------------------- monitor telporter - start -
//   //are we using teleporter
//   if (%task.useTeleport)
//   {
//      %result = AIFindDeployedMPB(%client);//new function in aiVehicle.cs
//      %closestMPB = getWord(%result, 0);
//      %closestMPBDist = getWord(%result, 1);
//      %result = SweepForTeleporters(%client);//new function in aiVehicle.cs
//      %closestTel = getWord(%result, 0);
//      %closestTelDist = getWord(%result, 1);
//      if (%closestMPB > 0 && %closestTel > 0)
//      {
//         //we are done teleporting
//         if (%closestMPBDist < %closestTelDist)
//         {
//            //reset the clients inventory status
//            if (%client.needEquipment)
//            {
//               %result = AIFindClosestInventory(%client, 0);
//	       %closestInv = getWord(%result, 0);
//               %client.invToUse = %closestInv;
//            }
//            %task.useTeleport = false;
//            return;
//         }
//
//         if (%closestTelDist < 2)
//            %client.pressJump();
//         else
//         {
//            %client.stepMove(%closestTel.getWorldBoxCenter(), 0.25);
//            return;
//         }
//      }
//      else
//         %task.useTeleport = false;
//   }
//   //--------------------------------------------------- monitor telporter - end -

   //if deployable got killed before we get to it - Lagg...
   if (!isObject(%task.targetObject))
   {
       %client.setTargetObject(-1);

      //if this task is the objective task, choose a new objective
      if (%task == %client.objectiveTask)
         {
            AIUnassignClient(%client);
	    Game.AIChooseGameObjective(%client);
            return;
	 }
    }
      if (%task.targetObject.getDamagePercent() > 0)
      {
         //make sure we still have equipment
		%client.needEquipment = AINeedEquipment(%task.equipment, %client);
         if (%client.needEquipment)
         {
         //if this task is the objective task, choose a new objective
         if (%task == %client.objectiveTask)
			{
            AIUnassignClient(%client);
	         Game.AIChooseGameObjective(%client);
				return;
			}
         }
      
		if (%task.deployed)
		{
			//see if we're within range of the deploy location
		   %clLoc = %client.player.position;
		   %distance = VectorDist(%clLoc, %task.repairLocation);
			%dist2D = VectorDist(%client.player.position, getWords(%task.repairLocation, 0, 1) SPC getWord(%client.player.position, 2));

			//set the aim when we get near the target...  this will be overwritten when we're actually trying to repair deployed
 			if (%distance < 10 && %dist2D < 10)
 		      %client.aimAt(%task.location, 1000);

			//see if we're at the deploy location
		   if ((%client.pathDistRemaining(20) > %distance + 0.25) || %dist2D > 0.3)
			{
	         %client.setTargetObject(-1);
		      %client.stepMove(%task.repairLocation, 0.25);
			}
			else
			{
				%client.stop();
                                %client.setTargetObject(%task.targetObject, 12, "Repair");//increased range - Lagg...
			}
		}
		else
		{
                        //modified here in case bot gets stuck trying to get to repair spot - Lagg... - 4-21-2003
			%currentTime = getSimTime();
			if (%currentTime > %task.needToRangeTime)
			{
				//force a rangeObject every 45 seconds...
                                %task.needToRangeTime = %currentTime + 45000;
				%client.setTargetObject(-1);
                                %client.setDangerLocation(%task.targetObject.position, 15);
                                //%client.player.cycleWeapon();
                                //if ( !%client.player.getImageTrigger( $BackpackSlot ) )
                                   //%client.player.setImageTrigger( $BackpackSlot, true );
                                
                                //if the objective marker was moved than we have a problemed target
                                //and we move to the objective marker to fix bot getting stuck trying
                                //to repair object - Lagg... 10-10-2003            
                                
                                if (%task.targetObject.getDataBlock().getName() $= "MobileBaseVehicle")
                                   %client.stepRangeObject(%task.targetObject, "DefaultRepairBeam", 9, 10);            
                                else if (%task.targetObject.getWorldBoxCenter() == %task.location)
                                   %client.stepRangeObject(%task.targetObject, "DefaultRepairBeam", 2, 4);
                                else
	                           %client.stepMove(%task.location);
			}

	      //if we've ranged the object, start repairing, else unset the object
	      else if (%client.getStepStatus() $= "Finished")
			{
				//dissolve the human control link
				if (%task == %client.objectiveTask)
					aiReleaseHumanControl(%client.controlByHuman, %client);

	                        %client.setTargetObject(%task.targetObject, 12, "Repair");
                                //if (%task.targetObject.getDataBlock().getName() $= "MobileBaseVehicle")
                                   //echo("REPAIRING A MPB = " @ getTaggedString(%client.name));
			}
	      else
	         %client.setTargetObject(-1);
		}
   }
   else
   {
      %client.setTargetObject(-1);
      
      //if this task is the objective task, choose a new objective
      if (%task == %client.objectiveTask)
		{
         AIUnassignClient(%client);
			Game.AIChooseGameObjective(%client);
		}
   }
}